#pragma once
#include <SDL2/SDL.h>
#include <string>
#include <Nes_Apu.h>
#include "common.hpp"
#include <switch.h>

namespace GUI {

const int TEXT_CENTER  = -1;
const int TEXT_RIGHT   = -2;
const unsigned FONT_SZ = 13;
extern const unsigned WIDTH;
extern const unsigned HEIGHT;
extern SDL_Window *window;
extern SDL_Renderer *renderer;
extern SDL_Texture *gameTexture;
extern SDL_Texture *background;

void init();
void toggle_pause();
SDL_Scancode query_key();
int query_button();
void run();

SDL_Texture* gen_text(std::string text, SDL_Color color);
void render_texture(SDL_Texture* texture, int x, int y);

uint8_t get_joypad_state(int n);
void new_frame(uint32_t* pixels);
void new_samples(const blip_sample_t* samples, size_t count);
void set_size(int mul);

}
